program lab2;
uses fmm, crt;
const n=3;
type
      data0=array[1..n,1..n] of real;
var
      t,h,tkon:float;
      data1:data0;
      i,j:byte;
      iflag:integer;
      iwork:ivec5;
      work:rvecn;
      data2,zm,z:floatvector;
      dat,res:text;
{___________________________________________________________________________________}
procedure data(var f: text); {Input data}
begin
  assign(f, 'd:\ds\spRitik\Polytech\Predmet\Math\NUMANA~1\LAB\3-1\2\data.txt');
  reset(f);
  for i:=1 to n do
    if i=n then
       begin
	 readln(f,zm[i]);
	 z[i]:=zm[i];
       end
    else
       begin
	 read(f,zm[i]);
	 z[i]:=zm[i];
       end;
  for i:=1 to n do
    for j:=1 to n do
      if (i=n)and(j=n) then
	 readln(f,data1[i,j])
      else
	 read(f,data1[i,j]);
  for i:=1 to n do
  begin
    read(f,data2[i]);
    end;
  close(f);
      end;
{____________________________________________________________________________________________}
procedure calch;  {Calculation of a step of integration}
begin
  h:=0;
  for i:=1 to n do
  begin
    for j:=1 to n do
    begin
      h:=h+sqr(data1[i,j]);
      end;
      end;
  t:=sqrt(h);
  h:=2/t;
  t:=0;
end;
{_____________________________________________________________________________________________}
procedure prodm(data11:data0;a:floatvector;var cal:floatvector); {Product of matrixes}
var
   i,j:byte;
begin
 for i:=1 to n do
   for j:=1 to n do
     cal[i]:=cal[i]+data11[i,j]*a[j];
end;

{______________________________________________________________________________________________}
procedure multmn(a:floatvector;k:real;var cal:floatvector); {Multiplication of a matrix to number}
var
   i:byte;
begin
 for i:=1 to n do
   cal[i]:=a[i]*k;
end;

{______________________________________________________________________________________________}
procedure addm(a,b:floatvector;var cal:floatvector);  {Addition of matrixes}
var
   i:byte;
begin
 for i:=1 to n do
   cal[i]:=a[i]+b[i];
end;

{________________________________________________________________________________________________}
procedure calcf(data11:data0;zm1,data21:floatvector;var fm1:floatvector);    {Calculation f(t,z(t)) }
var
   p:floatvector;
begin
 for i:=1 to n do
   p[i]:=0;
 prodm(data11,zm1,p);
 addm(p,data21,fm1);
end;

{______________________________________________________________________________________________}
procedure calcz(data11:data0;var zm1:floatvector;data21:floatvector;h1:float); {Calculation z(t)}
var
   p,p1,fm,fm23,zm23:floatvector;
begin
     p[i]:=0;
     p[i]:=0;
     fm[i]:=0;
     fm23[i]:=0;
     zm23[i]:=0;
 calcf(data11,zm1,data21,fm);
 multmn(fm,2*h1/3,p);
 addm(zm1,p,zm23);
 calcf(data11,zm23,data21,fm23);
 multmn(fm23,3,p);
 multmn(fm,1,p1);
 addm(p1,p,p);
 multmn(p,h1/4,p1);
 addm(zm1,p1,zm1);
end;


{_____________________________________________________________________________________________________}
procedure MyOutput(data11:data0;data21:floatvector;var zm1:floatvector;t1,h1:float;var tkon1:float;var f:text);
{Output my results}
var
   i,j:byte;
   m:integer;
   norm,norm1,norm2:real;
begin
 m:=1;
 rewrite(f);
 writeln(f,'             The table of my results               ');
 writeln(f,'');
 write(f,m:2,'   ');
 write(f,'t=',t1:10:4,' ');
 for i:=1 to n do
 write(f,zm1[i]:10:6,' ');
 repeat
   m:=m+1;
   t1:=t1+h1;
   norm1:=norm2;
   calcz(data1,zm1,data2,h1);
   writeln;
   writeln(f,'');
   write(f,m:2,'   ');
   write(f,'t=',t1:10:4,' ');
   for i:=1 to n do
   write(f,zm1[i]:10:6,' ');
   norm:=0;
   for i:=1 to n do
   norm:=norm+sqr(zm1[i]);
   norm2:=sqrt(norm);
 until abs(norm2-norm1)<0.000001;
 tkon1:=t1;
 close(f);
end;

{___________________________________________________________________________________________________}
{$F+}
procedure f(t1:float;var zm1,fm:floatvector); {Input procedure for RKF45}
var
   p:floatvector;
begin
 for i:=1 to n do
   p[i]:=0;
 prodm(data1,zm1,p);
 addm(p,data2,fm);
end;
{$F-}

{_____________________________________________________________________________________________________}
procedure checkiflag(var iflag1:integer;var abserr1,relerr1:float); {Check IFLAG}
begin
 case iflag1 of
   5: abserr1:=1E-9;
   6: begin
	relerr1:=10*relerr1;
	iflag1:=2;
      end;
   7: iflag1:=2;
 end;
end;

{____________________________________________________________________________________________________}
procedure OutputRKF45(var zm1:floatvector;t1,h1,tkon1:float;var ff:text);  {Output RKF45}
var
   t2,tout,relerr,abserr:float;
   iflag,i,m:integer;
   iwork:ivec5;
   work:rvecn;
   zm23: floatvector;
begin
 iflag:=1;
 t2:=t1;
 tout:=t1;
 relerr:=1E-6;
 abserr:=0;
 rkf45(@f,n,zm1,t1,tout,relerr,abserr,iflag,work,iwork);
 append(ff);
 writeln(ff,'');
 writeln(ff,'');
 writeln(ff,'            The table of RKF45 results             ');
 writeln(ff,'');
 m:=1;
 write(ff,m:2,'   ');
 write(ff,'t=',t1:10:4,' ');
 for i:=1 to n do
     write(ff,' ',zm1[i]:10:6);
 writeln(ff,'   ',iflag);
 t1:=t2;
 repeat
   m:=m+1;
   checkiflag(iflag,abserr,relerr);
   t2:=t1;
   tout:=tout+h1;
   rkf45(@f,n,zm1,t1,tout,relerr,abserr,iflag,work,iwork);
   checkiflag(iflag,abserr,relerr);
   write(ff,m:2,'   ');
   write(ff,'t=',t1:10:4,' ');
   for i:=1 to n do
     begin
       write(ff,' ',zm1[i]:10:6);
     end;
   writeln(ff,'   ',iflag);
 until t1>=tkon1;
 close(ff);
end;

{___________________________________________________________________________________}
begin {Main program}
  tkon:=0;
  data(dat);
  assign(res,'d:\ds\spRitik\Polytech\Predmet\Math\NUMANA~1\LAB\3-1\2\res.txt');
  calch;
  MyOutput(data1,data2,zm,t,h,tkon,res);
  for i:=1 to n do
  begin
    zm[i]:=z[i];
    end;
  t:=0;
  OutputRKF45(zm,t,h,tkon,res);
end.